package org.nl.acs.address.service;

import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.address.domain.Address;
import org.nl.acs.address.service.dto.AddressDto;
import org.nl.acs.address.service.dto.AddressQueryParam;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-10
*/
public interface AddressService extends CommonService<Address>  {

    static final String CACHE_KEY = "sysInterfaceMethodsAddress";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<SysInterfaceMethodsAddressDto>
    */
    PageInfo<AddressDto> queryAll(AddressQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<SysInterfaceMethodsAddressDto>
    */
    List<AddressDto> queryAll(AddressQueryParam query);

    Address getById(String id);
    AddressDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(AddressDto resources);
    int updateById(AddressDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<SysInterfaceMethodsAddressDto> all, HttpServletResponse response) throws IOException;



    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<AddressDto>
     */
    List<AddressDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param methods_id ID
     * @return Address
     */
//    AddressDto findById(String methods_id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return Address
     */
    AddressDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(AddressDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(AddressDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<AddressDto> dtos, HttpServletResponse response) throws IOException;
}
